include masm32rt.inc

    DlgProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
    TabsToSpaces1   PROTO   :DWORD,:DWORD
    TabsToSpaces2   PROTO   :DWORD,:DWORD
    TabsToSpaces3   PROTO   :DWORD,:DWORD

.data
    szDest          db 3072 dup(0)              ; easy to see in debugger
    
    szSource        db '---- ---- ----',13,10   ; spaced for GUI tabbing
                    db '	one tab',13,10
                    db '    4 spaces',13,10
                    db '		two tabs',13,10
                    db '        8 spaces',13,10
                    db '			three tabs',13,10
                    db '            12 spaces',13,10
                    db '				four tabs',13,10
                    db '                16 spaces',13,10
                    db '--- --- --- ---',13,10
                    db '	           | 0 spaces, tab, 11 space',13,10
                    db ' 	           | 1 spaces, tab, 11 space',13,10
                    db '  	           | 2 spaces, tab, 11 space',13,10
                    db '   	           | 3 spaces, tab, 11 space',13,10
                    db '    	       | 4 spaces, tab, 7 spaces',13,10
                    db '     	       | 5 spaces, tab, 7 spaces',13,10
                    db '      	       | 6 spaces, tab, 7 spaces',13,10
                    db '       	       | 7 spaces, tab, 7 spaces',13,10
                    db '-- -- -- -- --',13,10
                    db '	12345678...0 chars, tab, 8 chars',13,10
                    db '1	12345678...1 chars, tab, 8 chars',13,10
                    db '12	12345678...2 chars, tab, 8 chars',13,10
                    db '123	12345678...3 chars, tab, 8 chars',13,10
                    db '1234	1234...4 chars, tab, 4 chars',13,10
                    db '12345	1234...5 chars, tab, 4 chars',13,10
                    db '123456	1234...6 chars, tab, 4 chars',13,10
                    db '1234567	1234...7 chars, tab, 4 chars',13,10
                    db '- - - - - - - -',13,10
                    db '0               | 16-chr space-ramp',13,10
                    db ' 1              |',13,10
                    db '  2             |',13,10
                    db '   3            |',13,10
                    db '    4           |',13,10
                    db '     5          |',13,10
                    db '      6         |',13,10
                    db '       7        |',13,10
                    db '        8       |',13,10
                    db '         9      |',13,10
                    db '          10    |',13,10
                    db '           11   |',13,10
                    db '            12  |',13,10
                    db '             13 |',13,10
                    db '              14|',13,10
                    db '               15',13,10
                    db '                16',0

.data?
    hFont           dd ?
    TabWidth        dd ?
    hInstance       dd ?

.code
start:

	invoke GetModuleHandle,NULL
	mov hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,101,NULL,addr DlgProc,NULL
	invoke ExitProcess,0


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov	eax,uMsg
    .if eax==WM_INITDIALOG
        fn CreateFont,14,0,0,0,0,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,\
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,\
            FIXED_PITCH or FF_DONTCARE,"Courier New"
        mov hFont,eax
        invoke SendDlgItemMessage,hWin,1003,WM_SETFONT,hFont,0
        invoke SendDlgItemMessage,hWin,1004,WM_SETFONT,hFont,0

        mov TabWidth,16     ; arbitrary number (DialogBoxUnits)
        invoke SendDlgItemMessage,hWin,1003,EM_SETTABSTOPS,1,offset TabWidth
        invoke SendDlgItemMessage,hWin,1004,EM_SETTABSTOPS,1,offset TabWidth

        invoke SetDlgItemText,hWin,1003,addr szSource
        invoke TabsToSpaces1,addr szDest,addr szSource
        ;invoke TabsToSpaces2,addr szDest,addr szSource
        ;invoke TabsToSpaces3,addr szDest,addr szSource
        invoke SetDlgItemText,hWin,1004,addr szDest
        
        invoke SendDlgItemMessage,hWin,1003,EM_SETSEL,-1,0
        
    .elseif eax==WM_COMMAND

    .elseif eax==WM_CLOSE
        invoke DeleteObject,hFont
        invoke EndDialog,hWin,0
    .else
        mov	eax,FALSE
        ret
    .endif
    mov	eax,TRUE
    ret
DlgProc endp


TabsToSpaces1 proc private uses esi edi lpDest:DWORD,lpSource:DWORD
    ;LOCAL inChrPos:DWORD                ; input line position counter
    ;LOCAL outChrPos:DWORD               ; output line pos counter

        cld                             ; always copy forwards
        mov esi,lpSource
        mov edi,lpDest

LoopIt: lodsd                           ; load 4 bytes into EAX
        mov cl,1                        ; flag as "loop"

        mov edx,eax                     ; must start after new line!
        cmp dl,0Ah                      ; search for linefeeds
        je Sub3
        cmp dh,0Ah
        je Sub2
        ror edx,16
        cmp dl,0Ah
        je Sub1
        cmp dh,0Ah
        je Sub0
        ror edx,16
        jmp StartD                      ; LF not found, look for spaces

Sub3:   sub esi,3                       ; always land at 0Ah+1
        jmp Out1                        ; correct ESI and try again
Sub2:   sub esi,2
        jmp Out2
Sub1:   sub esi,1
        jmp Out3
Sub0:   nop         ; still a problem here?
        jmp Out4
        
StartD: mov cl,0                        ; flag as "tab"
        cmp eax,20202020h               ; "    "?
        je OutTab
        and edx,0FFFFFF00h              ; strip off LSB
        cmp edx,20202000h               ; "x   "?
        je Out1
        and edx,0FFFF0000h
        cmp edx,20200000h               ; "xx  "?
        je Out2
        and edx,0FF000000h
        cmp edx,20000000h               ; "xxx "?
        je Out3
        mov cl,1                        ; cannot tab, flag as "loop"

Out4:   test al,al                      ; copy all four bytes
        je OutNul                       ; check each for null
        stosb
        ror eax,8                       ; next byte in AL
Out3:   test al,al                      ; three bytes
        je OutNul
        stosb
        ror eax,8
Out2:   test al,al                      ; two bytes
        je OutNul
        stosb
        ror eax,8
Out1:   test al,al                      ; one byte
        je OutNul
        stosb
        cmp cl,1
        je LoopIt                       ; loop? or
OutTab: mov al,09h                      ; output tab
        stosb
        jmp LoopIt

OutNul: stosb
        ret
TabsToSpaces1 endp


end start
